﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {
	public int Lives=3;
	public string JumpAnimState="";
	public bool isDead=false;
	public bool isWalking=false;
	public bool isJumping=false;
	public bool isGrounded=true;
	public bool facingRight=true;
	public float h=0.0f;
	private const float speed=0.12f;
	private const float jumpHeight=600.0f;
	public GUIText messageBox;
	public BoxCollider2D collide;
	public Rigidbody2D physbody;
	public Transform groundCheck;
	public Animator anim,livesAnim;
	// Use this for initialization
	void Start(){
		RemoveItems();
		// Instantiate Game Components
		messageBox=(GUIText)gameObject.AddComponent("GUIText");
		collide=(BoxCollider2D)gameObject.AddComponent("BoxCollider2D");
		physbody=(Rigidbody2D)gameObject.AddComponent("Rigidbody2D");
		groundCheck=transform.Find("groundCheck");
		anim=GetComponent<Animator>();
		livesAnim=GameObject.Find("LivesCount").GetComponent<Animator>();
		// GUIText Settings
		messageBox.fontSize=12;
		messageBox.font=(Font)Resources.Load("Fonts/Scribble");
		messageBox.transform.position=new Vector3(0,0,-25);
		// Collider Settings
		collide.size=new Vector2(3,9.5f);
		collide.center=new Vector2(0,-0.7f);
		// Rigidbody2D Settings
		physbody.fixedAngle=true;
		transform.position=new Vector3(0,0,0);
		physbody.gravityScale=1.5f;
		// Lives Animator Settings
		livesAnim.SetInteger("Lives",Lives);
	}
	void Update(){
		if(Input.GetButton("Escape"))
			Application.Quit();
		if(!isDead){
			h=Input.GetAxis("Horizontal");
			if(Input.GetButtonDown("Jump")&&isGrounded&&GameObject.Find("ShoesL").renderer.enabled){
				rigidbody2D.AddForce(Vector2.up*jumpHeight);
			}
		}
		else{
			Lives-=1;
			if(Lives<=0){
				Application.LoadLevel("GameOver");
			}
			livesAnim.SetInteger("Lives",Lives);
			transform.position=GameObject.Find("Respawn").transform.position;
			GameObject.Find("Main Camera").transform.position=new Vector3(0,0,-10);
			isDead=false;
		}
	}
	// Update is called once per frame
	void FixedUpdate(){
		isWalking=(h!=0);
		anim.SetBool("Walking",isWalking);
		anim.SetBool("Jumping",!isGrounded);
		if(isWalking){
			//rigidbody2D.AddForce(Vector3.right*speed*h);
			transform.position+=new Vector3(h*speed,0,0);
		}
		// If the input is moving the player right and the player is facing left...
		if(h>0&&!facingRight)
			// ... flip the player.
			Flip();
		// Otherwise if the input is moving the player left and the player is facing right...
		else if(h<0&&facingRight)
			// ... flip the player.
			Flip();
	}
	void Flip ()
	{
		// Switch the way the player is labelled as facing.
		facingRight = !facingRight;
		
		// Multiply the player's x local scale by -1.
		Vector3 theScale = transform.localScale;
		theScale.x *= -1;
		transform.localScale = theScale;
	}
	void OnCollisionStay2D(Collision2D col){
		if(col.gameObject.name=="Collision")
			isGrounded=true;
	}
	void OnCollisionExit2D(Collision2D col){
		if(col.gameObject.name=="Collision")
			isGrounded=false;
	}
	void OnTriggerEnter(Collider other){
		Destroy(other.gameObject);
	}
	// User Defined Functions
	void RemoveItems(){
		GameObject.Find("ShoesR").renderer.enabled=false;
		GameObject.Find("ShoesL").renderer.enabled=false;
		GameObject.Find("Glasses").renderer.enabled=false;
	}
}